<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../../">
  <title data-ice="title">public/js/catalouge/Catalog_Entry/Catalog_Entry.js | archive-system-front-end</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
</head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/ArchiveSys/Web-Catalogue/archive-system-front-end.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js">js</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/moodral.js~moodral.html">moodral</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CONFIG">CONFIG</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge">js/catalouge</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System.js~Catalog_System.html">Catalog_System</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System_Base.js~Catalog_System_Base.html">Catalog_System_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-archive-connection">js/catalouge/Archive_Connection</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Archive_Connection/Archive_Connection.js~Archive_Connection.html">Archive_Connection</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry">js/catalouge/Catalog_Entry</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry.js~Catalog_Entry.html">Catalog_Entry</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js~Catalog_Entry_Base.html">Catalog_Entry_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry-moodral">js/catalouge/Catalog_Entry_Moodral</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry_Moodral/Catalog_Entry_Moodral.js~Catalog_Entry_Moodral.html">Catalog_Entry_Moodral</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-filter">js/catalouge/Filter</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter.js~Filter.html">Filter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter_Base.js~Filter_Base.html">Filter_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-page-headers">js/catalouge/Page_Headers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Page_Headers/Page_Headers.js~Page_Headers.html">Page_Headers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-toolkit">js/toolkit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/baseToolkit.js~toolkit.html">toolkit</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~baseStorageToolkitExtention.html">baseStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~permanentStorageToolkitExtention.html">permanentStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~sessionStorageToolkitExtention.html">sessionStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/contentToolkitExtention.js~contentToolkitExtention.html">contentToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/endlessScrollToolkitExtention.js~endlessScrollToolkitExtention.html">endlessScrollToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/eventToolkitExtention.js~eventToolkitExtention.html">eventToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/formToolkitExtention.js~formToolkitExtention.html">formToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/httpConnectionsToolkitExtention.js~httpConnectionsToolkitExtention.html">httpConnectionsToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/styleToolkitExtention.js~styleToolkitExtention.html">styleToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/urlToolkitExtention.js~urlToolkitExtention.html">urlToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-aggregator">aggregator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-NOTHING">NOTHING</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">public/js/catalouge/Catalog_Entry/Catalog_Entry.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import { Catalog_Entry_Base as CEB } from &apos;./Catalog_Entry_Base.js&apos;;

import { aggregator, toolkit } from &apos;./../../toolkit/baseToolkit.js&apos;;
import { eventToolkitExtention } from &apos;./../../toolkit/eventToolkitExtention.js&apos;

/**
 * The toolkit used throughout this file
 */

class tk extends aggregator(toolkit, eventToolkitExtention) {};

/**
 * This is the Catalog Entry Displayer.
 * This wraps the Catalog Entry Base and handles generateing all the content
 * @todo Should be renamed to being a more generic name.
 * @extends {Catalog_Entry_Base}
 */
export class Catalog_Entry extends CEB {
  /**
   * The constructor for books.
   * It sets all the local attributes.
   * @public
   * @param {Object} bookData - Book Data object containing the property&apos;s of the book.
   * @param {Object} catalougeObject - The parrent catalogue.
   */
  constructor(bookData, catalogObject, HTTP_Entrypoint){

    super(bookData, catalogObject);

    /**
     * The base HTTP Entrypoint
     * @type {String}
     */
    this.HTTP_Entrypoint = HTTP_Entrypoint;

    /**
     * This helps with looking for the catalouge entry.
     * @private
     * @type {{raw: string, hashed: string}}
     */
    let __domID = {
      &apos;RAW&apos;: &apos;CI_&apos; + this.id,
      &apos;HASHED&apos;: &apos;#CI_&apos; + this.id
    };

    /**
     * Contains CSS Selectors for vairious parts of the code.
     * @protected
     * @type {Enum&lt;String&gt;}
     */
    this.css_selectors = {&apos;AUTHOR_TEXT&apos;: __domID.HASHED + &apos; .c-author&apos;, &apos;DOM_ID&apos;: __domID};

  }

  /**
   * Generates HTML of the catalouge entry.
   *
   * Every sub-vairable should be a seperate function for future-proofing.
   * @protected
   * @return {Node} The Node with the entry.
   */
  __generateHTML() {
    let html = &quot;&quot;;
    {
      {
        html += this.__image();
        html += &apos;&lt;div class=&quot;c-top&quot;&gt;&apos;;
        {
          html += &apos;&lt;div class=&quot;c-line&quot;&gt;&apos;;
          {
            html += this.__title();
            html += this.__author();
            html += this.__publisher();
            html += &apos;&lt;span&gt;&#x2606;&lt;/span&gt;&apos;;
          }
          html += &apos;&lt;/div&gt;&apos;;
          html += &apos;&lt;div class=&quot;c-line&quot;&gt;&apos;;
          {
            html += this.__catagory();
          }
          html += &apos;&lt;/div&gt;&apos;;
          html += &apos;&lt;div class=&quot;c-line&quot;&gt;&apos;;
          {
            html += this.__rating();
            html += this.__status();
          }
          html += &apos;&lt;/div&gt;&apos;;
          html += &apos;&lt;div class=&quot;c-line&quot;&gt;&apos;;
          {
            html += this.__chapters();
            html += this.__wordCount();
          }
          html += &apos;&lt;/div&gt;&apos;;
        }
        html += &apos;&lt;/div&gt;&apos;;
        html += &apos;&lt;div class=&quot;c-main&quot;&gt;&apos;;
        {
          html += &apos;&lt;blockquote class=&quot;c-blurb&quot;&gt;&apos; + this.blurb + &apos;&lt;/blockquote&gt;&apos;;
          html += &apos;&lt;div class=&quot;c-facts&quot;&gt;&apos;;
          {
            html += this.__genres();
            html += this.__published();
            html += this.__updated();
            html += this.__downloaded();
            html += this.__checked();
            html += this.__characters();
            html += this.__pairings();

          }
          html += &apos;&lt;/div&gt;&apos;;
        }
        html += &apos;&lt;/div&gt;&apos;;
      }
    }

    let wrappingDiv = document.createElement(&apos;div&apos;);
    wrappingDiv.id = this.css_selectors.DOM_ID.RAW;
    wrappingDiv.classList.add(&apos;z-list&apos;);
    if(this.hidden &gt;= 1){
      wrappingDiv.classList.add(&apos;hidden&apos;);
    }
    wrappingDiv.style[&apos;display&apos;] = &apos;block&apos;;
    wrappingDiv.innerHTML = html

    return wrappingDiv;
  }

  /**
   * Adds the HTML of the catalouge entry to the DOM useing a displayerObject.
   *
   * This actually just calls __generateHTML() and then appends the returned HTML.
   * @public
   * @param {toolkit} displayerObject - Toolkit displayer object that can append HTML.
   */
  addHTML(displayerObject){
    let html = this.__generateHTML();
    displayerObject.appendHTML(html);
  }

  /**
   * Adds event listeners to the catalouge entry.
   *
   * Should only be called after the html is added.
   * @public
   */
  addEventListeners(){
    let __self = this;
    let authorTK = new tk(this.css_selectors.AUTHOR_TEXT)
    authorTK.addListener(&apos;click&apos;, (e) =&gt; {__self.__transferAuthorToSearch();})
  }

  /**
   * Code to add this entry to the DOM.
   *
   * Adds the entry to the dom and sets event triggers
   * @public
   * @param {toolkit} displayerObject - Toolkit displayer object that can append HTML.
   */
  addEntry(displayerObject){
    this.addHTML(displayerObject);
    this.addEventListeners();
  }

  /* Reduces redundancy in content displayers */

  /**
   * Generates DOMString of lower metadata info.
   *
   * This is to reduce redundancy of the lower functions and to reduce probability of bugs.
   * @private
   * @param {string} start - What the info is about
   * @param {string} tagClass - What class the css class should be
   * @param {string} content - what the actual value should be
   * @param {string|boolean} [title=false] - what the hover text should be
   * @param {Object|boolean} [data=false] - ! IGNORED !
   * @param {boolean} [tagStart=false] - ! IGNORED !
   * @return {DOMString}
   * @example this.__lowerInfo(&quot;Published&quot;, &quot;published&quot;, &quot;02/19/2018 - 12&quot;, &quot;02/19/2018 - 12:00:00&quot;);
   * @todo make this one work just like the upper info one. (Also switch them around in the object source)
   */
  __lowerInfo(start, tagClass, content, title, data, tagStart){
    let t = &quot;&quot;;
    // the start and class
    t += &apos;&lt;span class=&quot;c-bufferWidth&quot;&gt;&apos; + start + &apos;:&lt;/span&gt; &lt;span class=&quot;c-&apos; + tagClass + &apos;&quot;&apos;;
    // the title if needed
    if (title) {
      t += &apos; title=&quot;&apos; + title + &apos;&quot;&apos;;
    }
    // closeing it out and the content
    t += &apos;&gt;&apos; + content + &apos;&lt;/span&gt;&apos;;
    return t;
  }

  /**
   * Generates DOMString of upper metadata info.
   *
   * This is to reduce redundancy of the upper functions and to reduce probability of bugs.
   * @private
   * @param {string} start - What the info is about
   * @param {string} tagClass - What class the css class should be
   * @param {string} content - what the actual value should be
   * @param {string|boolean} [title=false] - what the hover text should be
   * @param {Object|boolean} [data=false] - data to add to the tag
   * @param {boolean} [tagStart=false] - if a dash should be added infront of the tag
   * @return {DOMString}
   * @example this.__lowerInfo(&quot;By&quot;, &quot;author&quot;, &quot;Jcc10&quot;, &quot;ID: 01&quot;, [{&apos;title&apos;:&apos;authorID&apos;, &apos;content&apos;:&apos;01&apos;}], true);
   */
  __topInfo(start, tagClass, content, title, data, tagStart){
    let t = &quot;&quot;;
    // the dash at the start of the tag if requested
    if (tagStart) {
      t += &apos; - &apos;;
    }
    // the start text and the class
    t += &apos;&apos; + start + &apos;: &lt;span class=&quot;c-&apos; + tagClass + &apos;&quot;&apos;;
    // the title if needed
    if (title) {
      t += &apos; title=&quot;&apos; + title + &apos;&quot;&apos;;
    }
    // the data if any exsists
    if (data) {
      // the actual looping function
      for(let dataItemIndex in data){
        t += &apos; data-&apos; + data[dataItemIndex].title + &apos;=&quot;&apos; + data[dataItemIndex].content + &apos;&quot;&apos;;
      }
    }
    // closeing it out and the content
    t += &apos;&gt;&apos; + content + &apos;&lt;/span&gt;&apos;;
    return t;
  }

  /**
   * Wraps content in a line div.
   * @private
   * @param {DOMString} content
   * @returns {DOMString}
   */
  __wrapInLine(content){
    return (&apos;&lt;div class=&quot;c-line&quot;&gt;&apos; + content + &apos;&lt;/div&gt;&apos;);
  }

 /* Individual content displayer&apos;s */

  /**
   * Generates the cover image tags
   * @private
   * @returns {DOMString}
   * @todo implement actual cover system.
   * @see https://www.google.com/search?q=base64+image+encoder&amp;ie=utf-8&amp;oe=utf-8
   */
  __image(){
   let defaultURL = this.HTTP_Entrypoint + &apos;images/d_60_90.jpg&apos;;
   return &apos;&lt;img class=&quot;c-image&quot; width=&quot;50&quot; height=&quot;66&quot; src=&quot;&apos; + defaultURL + &apos;&quot;&gt;&apos;;
  }
  /**
   * Generates the link to the reader.
   * @private
   * @returns {DOMString}
   */
  __link(){
    return this.HTTP_Entrypoint + &apos;reader.php?id=&apos; + this.id;
  }
  /**
   * Generates the title tags.
   * @private
   * @returns {DOMString}
   */
  __title(){
    return &apos;&lt;a class=&quot;c-title&quot; href=&quot;&apos; + this.__link() + &apos;&quot; target=&quot;_blank&quot;&gt;&apos; + this.title + &apos;&lt;/a&gt;&apos;;
  }
  /**
   * Generates the author tags.
   * @private
   * @returns {DOMString}
   */
  __author(){
    let c = (&apos;&lt;b&gt;&apos; + this.author.name + &apos;&lt;/b&gt;&apos;);
    let t = (&quot;ID: &quot; + this.author.id);
    let d = [{&apos;title&apos;:&apos;authorID&apos;,&apos;content&apos;:this.author.id}];
    return this.__topInfo(&apos;By&apos;, &apos;author&apos;, c, t, d, true);
  }
  /**
   * Generates the publisher tags.
   * @private
   * @returns {DOMString}
   */
  __publisher(){
    if (this.sourceURL === this.EMPTY){
      return &apos; &lt;a class=&quot;c-publisher&quot;&gt;&apos; + this.publisher + &apos;&lt;/a&gt; &amp;nbsp;&apos;;
    } else {
      return &apos; &lt;a class=&quot;c-publisher&quot; href=&quot;&apos; + this.sourceURL + &apos;&quot; target=&quot;_blank&quot;&gt;&apos; + this.publisher + &apos;&lt;/a&gt; &amp;nbsp;&apos;;
    }
  }
  /**
   * Generates the catagory tags.
   * @private
   * @returns {DOMString}
   */
  __catagory(){
    return this.__topInfo(&apos;Catagory&apos;, &apos;catagory&apos;, this.catagories);
  }
  /**
   * Generates the rating tags.
   * @private
   * @returns {DOMString}
   */
  __rating(){
    return this.__topInfo(&apos;Rating&apos;, &apos;rating&apos;, this.rating.short, this.rating.long);
  }
  /**
   * Generates the status tags.
   * @private
   * @returns {DOMString}
   * @todo re-work this when the new status get&apos;s implemented
   */
  __status(){
    if (this.status == 1) {
      return this.__topInfo(&apos;Status&apos;, &apos;status&apos;, &apos;Complete&apos;, false, false, true);
    } else if (this.status == 0) {
      return this.__topInfo(&apos;Status&apos;, &apos;status&apos;, &apos;In-Progress&apos;, false, false, true);
    }
    return this.__topInfo(&apos;Status&apos;, &apos;status&apos;, this.status, false, false, true);
  }
  /**
   * Generates the chapters tags.
   * @private
   * @returns {DOMString}
   */
  __chapters(){
    if (this.count.chapters === this.EMPTY){
      return &quot;&quot;;
    }
    return this.__topInfo(&apos;Chapters&apos;, &apos;chapters&apos;, this.addCommas(this.count.chapters));
  }
  /**
   * Generates the word count tags.
   * @private
   * @returns {DOMString}
   */
  __wordCount(){
    if (this.count.words === this.EMPTY){
      return &quot;&quot;;
    }
    return this.__topInfo(&apos;Word Count&apos;, &apos;words&apos;, this.addCommas(this.count.words), false, false, true);
  }
  /**
   * Generates the genre(s) tags.
   * @private
   * @returns {DOMString}
   */
  __genres(){
    if (this.genres === this.EMPTY){
      return &quot;&quot;;
    }
    let c = this.__lowerInfo(&apos;Genres&apos;, &apos;genres&apos;, this.genres);
    return (this.__wrapInLine(c));
  }
  /**
   * Generates the publish date tags.
   * @private
   * @returns {DOMString}
   */
  __published(){
    let c = &quot;&quot;
    if(this.dates.Published === this.EMPTY){
      c = this.__lowerInfo(&apos;Published&apos;, &apos;datePublished&apos;, &apos;Unknown&apos;)
    } else {
      c = this.__lowerInfo(&apos;Published&apos;, &apos;datePublished&apos;, this.truncateZeroDateTimes(this.dates.Published), this.dates.Published);
    }

    return (this.__wrapInLine(c));
  }
  /**
   * Generates the updated date tags.
   * @private
   * @returns {DOMString}
   */
  __updated(){
    if (this.dates.Updated === this.EMPTY){
      return &quot;&quot;;
    }
    let c = this.__lowerInfo(&apos;Updated&apos;, &apos;dateUpdated&apos;, this.truncateZeroDateTimes(this.dates.Updated), this.dates.Updated);
    return (this.__wrapInLine(c));
  }
  /**
   * Generates the downloaded date tags.
   * If a book has not yet been downloaded it will not have this tag.
   * @todo remove the dummy return when the database upgrade is completed.
   * @private
   * @returns {DOMString}
   */
  __downloaded(){
    // TEMP: this function is not actually being used right now.
    return &quot;&quot;;
    let c = &quot;&quot;;
    if (this.dates.Downloaded === this.EMPTY){
      c = this.__lowerInfo(&apos;Last Downloaded&apos;, &apos;dateDownloaded&apos;, &apos;Not Downloaded Yet&apos;);
    } else {
      c = this.__lowerInfo(&apos;Last Downloaded&apos;, &apos;dateDownloaded&apos;, this.truncateZeroDateTimes(this.dates.Downloaded), this.dates.Downloaded);
    }
    return (this.__wrapInLine(c));
  }
  /**
   * Generates the checked date tags.
   * @private
   * @returns {DOMString}
   */
  __checked(){
    let c = &quot;&quot;
    if(this.dates.Published === this.EMPTY){
      c = this.__lowerInfo(&apos;Last Check&apos;, &apos;dateChecked&apos;, &apos;Unknown&apos;)
    } else {
      c = this.__lowerInfo(&apos;Last Check&apos;, &apos;dateChecked&apos;, this.truncateZeroDateTimes(this.dates.Checked), this.dates.Checked);
    }

    return (this.__wrapInLine(c));
  }
  /**
   * Generates the characters tags.
   * @private
   * @returns {DOMString}
   */
  __characters(){
    if (this.characters === this.EMPTY){
      return &quot;&quot;;
    }
    let c = this.__lowerInfo(&apos;Characters&apos;, &apos;characters&apos;, this.characters);
    return (this.__wrapInLine(c));
  }
  /**
   * Generates the pairings tags.
   * @private
   * @returns {DOMString}
   */
  __pairings(){
    if (this.pairings === this.EMPTY){
      return &quot;&quot;;
    }
    let c = this.__lowerInfo(&apos;Pairings&apos;, &apos;pairings&apos;, this.pairings);
    return (this.__wrapInLine(c));
  }
}
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
